using CallCenterApi.DB;
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.DAL
{
    public partial class T_Client_UserGrade
    {
        public T_Client_UserGrade()
        { }
        #region  BasicMethod

        /// <summary>
        /// 得到最大ID
        /// </summary>
        public int GetMaxId()
        {
            return DbHelperSQL.GetMaxID("F_Id", "T_Client_UserGrade");
        }

        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(int F_Id)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) from T_Client_UserGrade");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            return DbHelperSQL.Exists(strSql.ToString(), parameters);
        }


        /// <summary>
        /// 增加一条数据
        /// </summary>
        public int Add(Model.T_Client_UserGrade model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("insert into T_Client_UserGrade(");
            strSql.Append("F_TypeId,F_Title,F_Grade,F_Note,UserId,UserCode,F_CreateTime,F_UpdateTime,F_DeleteTime,F_IsDelete,F_Order)");
            strSql.Append(" values (");
            strSql.Append("@F_TypeId,@F_Title,@F_Grade,@F_Note,@UserId,@UserCode,@F_CreateTime,@F_UpdateTime,@F_DeleteTime,@F_IsDelete,@F_Order)");
            strSql.Append(";select @@IDENTITY");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,100),
                    new SqlParameter("@F_Grade", SqlDbType.Int,4),
                    new SqlParameter("@F_Note", SqlDbType.NVarChar,500),
                    new SqlParameter("@UserId", SqlDbType.Int,4),
                    new SqlParameter("@UserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_Order", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TypeId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Grade;
            parameters[3].Value = model.F_Note;
            parameters[4].Value = model.UserId;
            parameters[5].Value = model.UserCode;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_UpdateTime;
            parameters[8].Value = model.F_DeleteTime;
            parameters[9].Value = model.F_IsDelete;
            parameters[10].Value = model.F_Order;

            object obj = DbHelperSQL.GetSingle(strSql.ToString(), parameters);
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Client_UserGrade model)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("update T_Client_UserGrade set ");
            strSql.Append("F_TypeId=@F_TypeId,");
            strSql.Append("F_Title=@F_Title,");
            strSql.Append("F_Grade=@F_Grade,");
            strSql.Append("F_Note=@F_Note,");
            strSql.Append("UserId=@UserId,");
            strSql.Append("UserCode=@UserCode,");
            strSql.Append("F_CreateTime=@F_CreateTime,");
            strSql.Append("F_UpdateTime=@F_UpdateTime,");
            strSql.Append("F_DeleteTime=@F_DeleteTime,");
            strSql.Append("F_IsDelete=@F_IsDelete,");
            strSql.Append("F_Order=@F_Order");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_TypeId", SqlDbType.Int,4),
                    new SqlParameter("@F_Title", SqlDbType.VarChar,100),
                    new SqlParameter("@F_Grade", SqlDbType.Int,4),
                    new SqlParameter("@F_Note", SqlDbType.NVarChar,500),
                    new SqlParameter("@UserId", SqlDbType.Int,4),
                    new SqlParameter("@UserCode", SqlDbType.VarChar,50),
                    new SqlParameter("@F_CreateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_UpdateTime", SqlDbType.DateTime),
                    new SqlParameter("@F_DeleteTime", SqlDbType.DateTime),
                    new SqlParameter("@F_IsDelete", SqlDbType.Int,4),
                    new SqlParameter("@F_Order", SqlDbType.Int,4),
                    new SqlParameter("@F_Id", SqlDbType.Int,4)};
            parameters[0].Value = model.F_TypeId;
            parameters[1].Value = model.F_Title;
            parameters[2].Value = model.F_Grade;
            parameters[3].Value = model.F_Note;
            parameters[4].Value = model.UserId;
            parameters[5].Value = model.UserCode;
            parameters[6].Value = model.F_CreateTime;
            parameters[7].Value = model.F_UpdateTime;
            parameters[8].Value = model.F_DeleteTime;
            parameters[9].Value = model.F_IsDelete;
            parameters[10].Value = model.F_Order;
            parameters[11].Value = model.F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Client_UserGrade ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            int rows = DbHelperSQL.ExecuteSql(strSql.ToString(), parameters);
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }
        /// <summary>
        /// 批量删除数据
        /// </summary>
        public bool DeleteList(string F_Idlist)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("delete from T_Client_UserGrade ");
            strSql.Append(" where F_Id in (" + F_Idlist + ")  ");
            int rows = DbHelperSQL.ExecuteSql(strSql.ToString());
            if (rows > 0)
            {
                return true;
            }
            else
            {
                return false;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Client_UserGrade GetModel(int F_Id)
        {

            StringBuilder strSql = new StringBuilder();
            strSql.Append("select  top 1 F_Id,F_TypeId,F_Title,F_Grade,F_Note,UserId,UserCode,F_CreateTime,F_UpdateTime,F_DeleteTime,F_IsDelete,F_Order from T_Client_UserGrade ");
            strSql.Append(" where F_Id=@F_Id");
            SqlParameter[] parameters = {
                    new SqlParameter("@F_Id", SqlDbType.Int,4)
            };
            parameters[0].Value = F_Id;

            Model.T_Client_UserGrade model = new Model.T_Client_UserGrade();
            DataSet ds = DbHelperSQL.Query(strSql.ToString(), parameters);
            if (ds.Tables[0].Rows.Count > 0)
            {
                return DataRowToModel(ds.Tables[0].Rows[0]);
            }
            else
            {
                return null;
            }
        }


        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Client_UserGrade DataRowToModel(DataRow row)
        {
            Model.T_Client_UserGrade model = new Model.T_Client_UserGrade();
            if (row != null)
            {
                if (row["F_Id"] != null && row["F_Id"].ToString() != "")
                {
                    model.F_Id = int.Parse(row["F_Id"].ToString());
                }
                if (row["F_TypeId"] != null && row["F_TypeId"].ToString() != "")
                {
                    model.F_TypeId = int.Parse(row["F_TypeId"].ToString());
                }
                if (row["F_Title"] != null && row["F_Title"].ToString() != "")
                {
                    model.F_Title = row["F_Title"].ToString();
                }
                if (row["F_Grade"] != null && row["F_Grade"].ToString() != "")
                {
                    model.F_Grade = int.Parse(row["F_Grade"].ToString());
                }
                if (row["F_Note"] != null)
                {
                    model.F_Note = row["F_Note"].ToString();
                }
                if (row["UserId"] != null && row["UserId"].ToString() != "")
                {
                    model.UserId = int.Parse(row["UserId"].ToString());
                }
                if (row["UserCode"] != null)
                {
                    model.UserCode = row["UserCode"].ToString();
                }
                if (row["F_CreateTime"] != null && row["F_CreateTime"].ToString() != "")
                {
                    model.F_CreateTime = DateTime.Parse(row["F_CreateTime"].ToString());
                }
                if (row["F_UpdateTime"] != null && row["F_UpdateTime"].ToString() != "")
                {
                    model.F_UpdateTime = DateTime.Parse(row["F_UpdateTime"].ToString());
                }
                if (row["F_DeleteTime"] != null && row["F_DeleteTime"].ToString() != "")
                {
                    model.F_DeleteTime = DateTime.Parse(row["F_DeleteTime"].ToString());
                }
                if (row["F_IsDelete"] != null && row["F_IsDelete"].ToString() != "")
                {
                    model.F_IsDelete = int.Parse(row["F_IsDelete"].ToString());
                }
                if (row["F_Order"] != null && row["F_Order"].ToString() != "")
                {
                    model.F_Order = int.Parse(row["F_Order"].ToString());
                }
            }
            return model;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select F_Id,F_TypeId,F_Title,F_Grade,F_Note,UserId,UserCode,F_CreateTime,F_UpdateTime,F_DeleteTime,F_IsDelete,F_Order ");
            strSql.Append(" FROM T_Client_UserGrade ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select ");
            if (Top > 0)
            {
                strSql.Append(" top " + Top.ToString());
            }
            strSql.Append(" F_Id,F_TypeId,F_Title,F_Grade,F_Note,UserId,UserCode,F_CreateTime,F_UpdateTime,F_DeleteTime,F_IsDelete,F_Order ");
            strSql.Append(" FROM T_Client_UserGrade ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            strSql.Append(" order by " + filedOrder);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /// <summary>
        /// 获取记录总数
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("select count(1) FROM T_Client_UserGrade ");
            if (strWhere.Trim() != "")
            {
                strSql.Append(" where " + strWhere);
            }
            object obj = DbHelperSQL.GetSingle(strSql.ToString());
            if (obj == null)
            {
                return 0;
            }
            else
            {
                return Convert.ToInt32(obj);
            }
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            StringBuilder strSql = new StringBuilder();
            strSql.Append("SELECT * FROM ( ");
            strSql.Append(" SELECT ROW_NUMBER() OVER (");
            if (!string.IsNullOrEmpty(orderby.Trim()))
            {
                strSql.Append("order by T." + orderby);
            }
            else
            {
                strSql.Append("order by T.F_Id desc");
            }
            strSql.Append(")AS Row, T.*  from T_Client_UserGrade T ");
            if (!string.IsNullOrEmpty(strWhere.Trim()))
            {
                strSql.Append(" WHERE " + strWhere);
            }
            strSql.Append(" ) TT");
            strSql.AppendFormat(" WHERE TT.Row between {0} and {1}", startIndex, endIndex);
            return DbHelperSQL.Query(strSql.ToString());
        }

        /*
		/// <summary>
		/// 分页获取数据列表
		/// </summary>
		public DataSet GetList(int PageSize,int PageIndex,string strWhere)
		{
			SqlParameter[] parameters = {
					new SqlParameter("@tblName", SqlDbType.VarChar, 255),
					new SqlParameter("@fldName", SqlDbType.VarChar, 255),
					new SqlParameter("@PageSize", SqlDbType.Int),
					new SqlParameter("@PageIndex", SqlDbType.Int),
					new SqlParameter("@IsReCount", SqlDbType.Bit),
					new SqlParameter("@OrderType", SqlDbType.Bit),
					new SqlParameter("@strWhere", SqlDbType.VarChar,1000),
					};
			parameters[0].Value = "T_Client_UserGrade";
			parameters[1].Value = "F_Id";
			parameters[2].Value = PageSize;
			parameters[3].Value = PageIndex;
			parameters[4].Value = 0;
			parameters[5].Value = 0;
			parameters[6].Value = strWhere;	
			return DbHelperSQL.RunProcedure("UP_GetRecordByPage",parameters,"ds");
		}*/

        #endregion  BasicMethod
        #region  ExtensionMethod

        #endregion  ExtensionMethod
    }
}
